package com.fjhx.account.controller.account;

import com.fjhx.account.entity.account.dto.AccountSubjectsDto;
import com.fjhx.account.entity.account.dto.AccountSubjectsSelectDto;
import com.fjhx.account.entity.account.vo.AccountSubjectsVo;
import com.fjhx.account.service.account.AccountSubjectsService;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 * 记账科目 前端控制器
 * </p>
 *
 * @author
 * @since 2024-03-18
 */
@RestController
@RequestMapping("/accountSubjects")
public class AccountSubjectsController {

    @Autowired
    private AccountSubjectsService accountSubjectsService;

    /**
     * 记账科目列表
     */
    @PostMapping("/list")
    public List<AccountSubjectsVo> list(@RequestBody AccountSubjectsSelectDto dto) {
        return accountSubjectsService.getList(dto);
    }

//    /**
//     * 记账科目分页
//     */
//    @PostMapping("/page")
//    public Page<AccountSubjectsVo> page(@RequestBody AccountSubjectsSelectDto dto) {
//        return accountSubjectsService.getPage(dto);
//    }
//
//    /**
//     * 记账科目明细
//     */
//    @PostMapping("/detail")
//    public AccountSubjectsVo detail(@RequestBody BaseSelectDto dto) {
//        return accountSubjectsService.detail(dto.getId());
//    }

    /**
     * 记账科目新增
     */
    @PostMapping("/add")
    public void add(@RequestBody AccountSubjectsDto accountSubjectsDto) {
        accountSubjectsService.add(accountSubjectsDto);
    }

    /**
     * 记账科目编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody AccountSubjectsDto accountSubjectsDto) {
        accountSubjectsService.edit(accountSubjectsDto);
    }

    /**
     * 记账科目删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        accountSubjectsService.delete(dto.getId());
    }

}
