package com.fjhx.account.controller.payee;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.account.entity.payee.dto.PayeeInfoDto;
import com.fjhx.account.entity.payee.dto.PayeeInfoSelectDto;
import com.fjhx.account.entity.payee.vo.PayeeInfoVo;
import com.fjhx.account.service.payee.PayeeInfoService;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * <p>
 * 收款单位 前端控制器
 * </p>
 *
 * @author
 * @since 2024-03-20
 */
@RestController
@RequestMapping("/payeeInfo")
public class PayeeInfoController {

    @Autowired
    private PayeeInfoService payeeInfoService;

    /**
     * 收款单位分页
     */
    @PostMapping("/page")
    public Page<PayeeInfoVo> page(@RequestBody PayeeInfoSelectDto dto) {
        return payeeInfoService.getPage(dto);
    }

    /**
     * 收款单位明细
     */
    @PostMapping("/detail")
    public PayeeInfoVo detail(@RequestBody BaseSelectDto dto) {
        return payeeInfoService.detail(dto.getId());
    }

    /**
     * 收款单位新增
     */
    @PostMapping("/add")
    public void add(@RequestBody PayeeInfoDto payeeInfoDto) {
        payeeInfoService.add(payeeInfoDto);
    }

    /**
     * 收款单位编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody PayeeInfoDto payeeInfoDto) {
        payeeInfoService.edit(payeeInfoDto);
    }

    /**
     * 收款单位删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        payeeInfoService.delete(dto.getId());
    }

}
