package com.fjhx.account.controller.payment;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.account.entity.payment.dto.PaymentTypeDto;
import com.fjhx.account.entity.payment.dto.PaymentTypeSelectDto;
import com.fjhx.account.entity.payment.vo.PaymentTypeVo;
import com.fjhx.account.service.payment.PaymentTypeService;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * <p>
 * 收付款类型 前端控制器
 * </p>
 *
 * @author
 * @since 2024-03-18
 */
@RestController
@RequestMapping("/paymentType")
public class PaymentTypeController {

    @Autowired
    private PaymentTypeService paymentTypeService;

    /**
     * 收付款类型分页
     */
    @PostMapping("/page")
    public Page<PaymentTypeVo> page(@RequestBody PaymentTypeSelectDto dto) {
        return paymentTypeService.getPage(dto);
    }

    /**
     * 收付款类型明细
     */
    @PostMapping("/detail")
    public PaymentTypeVo detail(@RequestBody BaseSelectDto dto) {
        return paymentTypeService.detail(dto.getId());
    }

    /**
     * 收付款类型新增
     */
    @PostMapping("/add")
    public void add(@RequestBody PaymentTypeDto paymentTypeDto) {
        paymentTypeService.add(paymentTypeDto);
    }

    /**
     * 收付款类型编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody PaymentTypeDto paymentTypeDto) {
        paymentTypeService.edit(paymentTypeDto);
    }

    /**
     * 收付款类型删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        paymentTypeService.delete(dto.getId());
    }

}
