package com.fjhx.account.entity.account.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 账户资金流水表
 * </p>
 *
 * @author
 * @since 2023-04-06
 */
@Getter
@Setter
@TableName("account_running_water")
public class AccountRunningWater extends BasePo {

    /**
     * 账户-管理表ID
     */
    private Long accountManagementId;

    /**
     * 业务ID
     */
    private Long businessId;

    /**
     * 流水类型。10：打款
     */
    private String type;

    /**
     * 收支类型：10 收入，20支出
     */
    private String status;

    /**
     * 金额
     */
    private BigDecimal amount;

    /**
     * 已认领总金额
     */
    private BigDecimal claimAmount;

    /**
     * 币种（字典account_currency）
     */
    private String currency;

    /**
     * 账户名
     */
    private String name;

    /**
     * 合同到账（10:是，20:否）
     */
    private String received;

    /**
     * 开户银行
     */
    private String openingBank;

    /**
     * 开户账号
     */
    private String accountOpening;

    /**
     * 交易时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date transactionTime;

    /**
     * 备注
     */
    private String remarks;

    /**
     * 是否认领
     */
    private Integer isClaim;

    /**
     * 汇率
     */
    private BigDecimal rate;


    /**
     * 打款记录id
     */
    private Long accountPaymentRecordsId;

    /**
     * 转人民币金额
     */
    private BigDecimal amountCny;

    /**
     * 归属公司id
     */
    private Long companyId;

    /**
     * 业务部门id
     */
    private Long deptId;
    /**
     * 我方账户名
     */
    private String myAccountName;
    /**
     * 我方开户账号
     */
    private String myAccountOpening;
    /**
     * 我方开户行
     */
    private String myOpeningBank;
    /**
     * 流水号
     */
    private String serialNumber;

    private Long registerUserId;

    /**
     * 确认备注
     */
    private String confirmRemark;

}
