package com.fjhx.account.entity.cost.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fjhx.common.controller.Label;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;

/**
 * <p>
 * 费控明细
 * </p>
 *
 * @author
 * @since 2024-03-18
 */
@Getter
@Setter
@TableName("cost_control_detail")
public class CostControlDetail extends BasePo {

    /**
     * 费控id
     */
    private Long costControlId;

    /**
     * 付款说明
     */
    @Label("付款说明")
    private String remark;

    /**
     * 供应商
     */
    @Label("供应商")
    private Long supplierId;

    /**
     * 收款单位
     */
    @Label("收款单位")
    private String payeeAccountId;

    /**
     * 申请备注
     */
    @Label("申请备注")
    private String applyRemark;

    /**
     * 抵扣工资月份
     */
    @Label("抵扣工资月份")
    private String deductionMonth;

    /**
     * 本期应付
     */
    @Label("本期应付")
    private String currentPayable;

    /**
     * 本期应付（抵扣后）
     */
    @Label("本期应付（抵扣后）")
    private String currentPayableDeduction;

    /**
     * 记账科目
     */
    @Label("记账科目")
    private Long accountSubjectsId;

    /**
     * 记账金额
     */
    @Label("记账金额")
    private BigDecimal money;

    /**
     * 快递公司
     */
    @Label("快递公司")
    private Long logisticsCompanyId;

    /**
     * 开票税点
     */
    @Label("开票税点")
    private String invoiceTaxPoint;

    /**
     * 结存预付款_含税
     */
    @Label("结存预付款_含税")
    private String balancePrepaidTax;

    /**
     * 结存预付款
     */
    @Label("结存预付款")
    private String balancePrepaid;

    /**
     * 帐期
     */
    @Label("帐期")
    private String accountPeriod;

    /**
     * 本账期金额
     */
    @Label("本账期金额")
    private String accountPeriodAmount;

    /**
     * 本账期金额_含税
     */
    @Label("本账期金额_含税")
    private String accountPeriodAmountTax;

    /**
     * 本账期调整金额
     */
    @Label("本账期调整金额")
    private String accountPeriodAdjustAmount;

    /**
     * 本期预付款_含税
     */
    @Label("本期预付款_含税")
    private String currentPrepaidTax;

    /**
     * 本期预付款
     */
    @Label("本期预付款")
    private String currentPrepaid;

    /**
     * 抵扣预付款_含税
     */
    @Label("抵扣预付款_含税")
    private String deductionPrepaidTax;

    /**
     * 抵扣预付款
     */
    @Label("抵扣预付款")
    private String deductionPrepaid;

    /**
     * 店铺id
     */
    @Label("店铺信息")
    private String shopId;

    /**
     * 费用类型
     */
    @Label("费用类型")
    private String costType;

    /**
     * 刷单时间
     */
    @Label("刷单时间")
    private String brushingTime;

    /**
     * 推广费类型
     */
    @Label("推广费类型")
    private String promotionFeeType;

    /**
     * 税费
     */
    @Label("税费")
    private String taxation;

    @Label("归还金额")
    private BigDecimal returnAmount;

}
