package com.fjhx.account.entity.cost.vo;

import com.fjhx.account.entity.cost.po.CostControlDetail;
import com.fjhx.common.controller.Label;
import com.fjhx.file.entity.ObsFile;
import lombok.Getter;
import lombok.Setter;

import java.util.List;

/**
 * 费控明细列表查询返回值实体
 *
 * @author
 * @since 2024-03-18
 */
@Getter
@Setter
public class CostControlDetailVo extends CostControlDetail {

    /**
     * 物流公司名称
     */
    private String logisticsName;

    /**
     * 物流公司税点
     */
    private Integer logisticsTaxPoints;

    /**
     * 物流公司开户名
     */
    private String logisticsAccountName;

    /**
     * 物流公司开户行
     */
    private String logisticsAccountBank;

    /**
     * 物流公司户账号
     */
    private String logisticsAccountNumber;

    /**
     * 供应商名称
     */
    private String supplierName;

    /**
     * 科目名称
     */
    private String subjectsName;

    /**
     * 核算项目名称
     */
    private String subjectsCalculateItemName;

    /**
     * 店铺名称
     */
    private String shopName;

    /**
     * 非发票附件 类型0
     */
    @Label("非发票附件")
    private List<ObsFile> fileList;

    /**
     * 发票附件 类型10
     */
    @Label("发票附件")
    private List<ObsFile> invoiceFileList;
}
