package com.fjhx.account.service.account;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.account.entity.account.dto.AccountSubjectsDto;
import com.fjhx.account.entity.account.dto.AccountSubjectsSelectDto;
import com.fjhx.account.entity.account.po.AccountSubjects;
import com.fjhx.account.entity.account.vo.AccountSubjectsVo;
import com.ruoyi.common.core.service.BaseService;

import java.util.List;

/**
 * <p>
 * 记账科目 服务类
 * </p>
 *
 * @author
 * @since 2024-03-18
 */
public interface AccountSubjectsService extends BaseService<AccountSubjects> {

    /**
     * 记账科目列表
     */
    List<AccountSubjectsVo> getList(AccountSubjectsSelectDto dto);

    /**
     * 记账科目分页
     */
    Page<AccountSubjectsVo> getPage(AccountSubjectsSelectDto dto);

    /**
     * 记账科目明细
     */
    AccountSubjectsVo detail(Long id);

    /**
     * 记账科目新增
     */
    void add(AccountSubjectsDto accountSubjectsDto);

    /**
     * 记账科目编辑
     */
    void edit(AccountSubjectsDto accountSubjectsDto);

    /**
     * 记账科目删除
     */
    void delete(Long id);

}
