package com.fjhx.account.service.cost.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.account.entity.cost.po.CostControlDetail;
import com.fjhx.account.entity.cost.vo.CostControlDetailVo;
import com.fjhx.account.mapper.cost.CostControlDetailMapper;
import com.fjhx.account.service.account.AccountSubjectsService;
import com.fjhx.account.service.cost.CostControlDetailService;
import com.fjhx.common.service.logistics.LogisticsCompanyInfoService;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 费控明细 服务实现类
 * </p>
 *
 * @author
 * @since 2024-03-18
 */
@Service
public class CostControlDetailServiceImpl extends ServiceImpl<CostControlDetailMapper, CostControlDetail> implements CostControlDetailService {


    @Autowired
    private AccountSubjectsService accountSubjectsService;
    @Autowired
    private LogisticsCompanyInfoService logisticsCompanyInfoService;

    @Override
    public List<CostControlDetailVo> getList(IWrapper wrapper) {
        List<CostControlDetailVo> list = this.baseMapper.getList(wrapper);

        //赋值记账科目
        accountSubjectsService.attributeAssign(list, CostControlDetailVo::getAccountSubjectsId, (detail, subjects) -> {
            detail.setSubjectsName(subjects.getSubjectsName());
            detail.setSubjectsCalculateItemName(subjects.getCalculateItemName());
        });
        //赋值物流公司信息
        logisticsCompanyInfoService.attributeAssign(list, CostControlDetailVo::getLogisticsCompanyId, (detail, logistics) -> {
            detail.setLogisticsName(logistics.getName());
            detail.setLogisticsTaxPoints(logistics.getTaxPoints());
            detail.setLogisticsAccountName(logistics.getAccountName());
            detail.setLogisticsAccountBank(logistics.getAccountBank());
            detail.setLogisticsAccountNumber(logistics.getAccountNumber());
        });

        return list;
    }

}
