package com.fjhx.account.service.payee.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.account.entity.payee.dto.PayeeInfoDto;
import com.fjhx.account.entity.payee.dto.PayeeInfoSelectDto;
import com.fjhx.account.entity.payee.po.PayeeInfo;
import com.fjhx.account.entity.payee.vo.PayeeInfoVo;
import com.fjhx.account.mapper.payee.PayeeInfoMapper;
import com.fjhx.account.service.payee.PayeeInfoService;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.springframework.stereotype.Service;


/**
 * <p>
 * 收款单位 服务实现类
 * </p>
 *
 * @author
 * @since 2024-03-20
 */
@Service
public class PayeeInfoServiceImpl extends ServiceImpl<PayeeInfoMapper, PayeeInfo> implements PayeeInfoService {

    @Override
    public Page<PayeeInfoVo> getPage(PayeeInfoSelectDto dto) {
        IWrapper<PayeeInfo> wrapper = getWrapper();

        wrapper.orderByAsc("pi", PayeeInfo::getSort);
        wrapper.orderByDesc("pi", PayeeInfo::getId);
        Page<PayeeInfoVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public PayeeInfoVo detail(Long id) {
        PayeeInfo PayeeInfo = this.getById(id);
        PayeeInfoVo result = BeanUtil.toBean(PayeeInfo, PayeeInfoVo.class);
        return result;
    }

    @Override
    public void add(PayeeInfoDto payeeInfoDto) {
        this.save(payeeInfoDto);
    }

    @Override
    public void edit(PayeeInfoDto payeeInfoDto) {
        this.updateById(payeeInfoDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
