package com.fjhx.account.service.payment;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.account.entity.payment.dto.PaymentTypeDto;
import com.fjhx.account.entity.payment.dto.PaymentTypeSelectDto;
import com.fjhx.account.entity.payment.po.PaymentType;
import com.fjhx.account.entity.payment.vo.PaymentTypeVo;
import com.ruoyi.common.core.service.BaseService;


/**
 * <p>
 * 收付款类型 服务类
 * </p>
 *
 * @author
 * @since 2024-03-18
 */
public interface PaymentTypeService extends BaseService<PaymentType> {

    /**
     * 收付款类型分页
     */
    Page<PaymentTypeVo> getPage(PaymentTypeSelectDto dto);

    /**
     * 收付款类型明细
     */
    PaymentTypeVo detail(Long id);

    /**
     * 收付款类型新增
     */
    void add(PaymentTypeDto paymentTypeDto);

    /**
     * 收付款类型编辑
     */
    void edit(PaymentTypeDto paymentTypeDto);

    /**
     * 收付款类型删除
     */
    void delete(Long id);

}
