package com.fjhx.common.controller.logistics;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.common.entity.logistics.dto.LogisticsCompanyInfoDto;
import com.fjhx.common.entity.logistics.dto.LogisticsCompanyInfoSelectDto;
import com.fjhx.common.entity.logistics.vo.LogisticsCompanyInfoVo;
import com.fjhx.common.service.logistics.LogisticsCompanyInfoService;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 * 物流公司信息 前端控制器
 * </p>
 *
 * @author
 * @since 2024-03-18
 */
@RestController
@RequestMapping("/logisticsCompanyInfo")
public class LogisticsCompanyInfoController {

    @Autowired
    private LogisticsCompanyInfoService logisticsCompanyInfoService;

    /**
     * 物流公司信息列表
     */
    @PostMapping("/list")
    public List<LogisticsCompanyInfoVo> list(@RequestBody LogisticsCompanyInfoSelectDto dto) {
        return logisticsCompanyInfoService.getList(dto);
    }

    /**
     * 物流公司信息分页
     */
    @PostMapping("/page")
    public Page<LogisticsCompanyInfoVo> page(@RequestBody LogisticsCompanyInfoSelectDto dto) {
        return logisticsCompanyInfoService.getPage(dto);
    }

    /**
     * 物流公司信息明细
     */
    @PostMapping("/detail")
    public LogisticsCompanyInfoVo detail(@RequestBody BaseSelectDto dto) {
        return logisticsCompanyInfoService.detail(dto.getId());
    }

    /**
     * 物流公司信息新增
     */
    @PostMapping("/add")
    public void add(@RequestBody LogisticsCompanyInfoDto logisticsCompanyInfoDto) {
        logisticsCompanyInfoService.add(logisticsCompanyInfoDto);
    }

    /**
     * 物流公司信息编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody LogisticsCompanyInfoDto logisticsCompanyInfoDto) {
        logisticsCompanyInfoService.edit(logisticsCompanyInfoDto);
    }

    /**
     * 物流公司信息删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        logisticsCompanyInfoService.delete(dto.getId());
    }

}
