package com.fjhx.common.service.logistics;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.common.entity.logistics.dto.LogisticsCompanyInfoDto;
import com.fjhx.common.entity.logistics.dto.LogisticsCompanyInfoSelectDto;
import com.fjhx.common.entity.logistics.po.LogisticsCompanyInfo;
import com.fjhx.common.entity.logistics.vo.LogisticsCompanyInfoVo;
import com.ruoyi.common.core.service.BaseService;

import java.util.List;

/**
 * <p>
 * 物流公司信息 服务类
 * </p>
 *
 * @author
 * @since 2024-03-18
 */
public interface LogisticsCompanyInfoService extends BaseService<LogisticsCompanyInfo> {

    /**
     * 物流公司信息列表
     */
    List<LogisticsCompanyInfoVo> getList(LogisticsCompanyInfoSelectDto dto);

    /**
     * 物流公司信息分页
     */
    Page<LogisticsCompanyInfoVo> getPage(LogisticsCompanyInfoSelectDto dto);

    /**
     * 物流公司信息明细
     */
    LogisticsCompanyInfoVo detail(Long id);

    /**
     * 物流公司信息新增
     */
    void add(LogisticsCompanyInfoDto logisticsCompanyInfoDto);

    /**
     * 物流公司信息编辑
     */
    void edit(LogisticsCompanyInfoDto logisticsCompanyInfoDto);

    /**
     * 物流公司信息删除
     */
    void delete(Long id);

}
