package com.fjhx.form.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;

@Getter
@Setter
public class ProductionReportBo {
    private Long id;
    /**
     * 工厂id
     */
    private Long factoryId;
    /**
     * 工厂名称
     */
    private String factoryName;
    /**
     * 订单号
     */
    private String orderCode;
    /**
     * 产品id
     */
    private Long productId;
    /**
     * 产品编号
     */
    private String productCode;
    /**
     * 产品名称
     */
    private String productName;
    /**
     * 产品长
     */
    private BigDecimal productLength;
    /**
     * 产品宽
     */
    private BigDecimal productWidth;
    /**
     * 产品高
     */
    private BigDecimal productHeight;
    /**
     * 产品颜色
     */
    private String productColor;
    /**
     * 生产数量
     */
    private BigDecimal quantity;
    /**
     * 交期
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date deliveryPeriod;
    /**
     * 完工时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date finishTime;
    /**
     * 是否逾期
     */
    private Integer isOverdue;
    /**
     * 逾期天数
     */
    private Integer overdueDay;
    /**
     * 及时率
     */
    private Integer timelyRate;

    /**
     * 原材料损耗数量
     */
    private BigDecimal rawLossCount;
    /**
     * 原材料损耗价格
     */
    private BigDecimal rawLossAmount;

    /**
     * 物料损耗数量
     */
    private BigDecimal bomLossCount;
    /**
     * 物料损耗价格
     */
    private BigDecimal bomLossAmount;

    /**
     * 返工数量
     */
    private Integer reworkCount;
    /**
     * 返工价格
     */
    private BigDecimal reworkAmount;
    /**
     * 错误率
     */
    private BigDecimal errRate;
}
