package com.fjhx.iot.entity.tda.vo;

import com.fjhx.iot.entity.tda.po.TdaDevice;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;
import java.util.Map;

/**
 * 设备管理列表查询返回值实体
 *
 * @author zlj
 * @since 2023-03-21
 */
@Getter
@Setter
public class TdaDeviceVo extends TdaDevice {

    /**
     * 行业名称
     */
    private String appName;

    /**
     * 产品名称
     */
    private String productName;

    /**
     * 华为tda产品设备类型
     */
    private String deviceType;

    /**
     * 设备状态
     */
    private String status;

    /**
     * 推送时间
     */
    private Date eventTime;

    /**
     * 其他字段
     */
    private Map<String, Object> other;

    /**
     * 归属公司名称
     */
    private String companyName;

    /**
     * 产品id
     */
    private Long productId;

    /**
     * 产品编号
     */
    private String productCode;
    /**
     * 产品长
     */
    private BigDecimal productLength;
    /**
     * 产品宽
     */
    private BigDecimal productWidth;
    /**
     * 产品高
     */
    private BigDecimal productHeight;
    /**
     * 产品颜色
     */
    private String productColor;

    /**
     * 生产订单号
     */
    private String orderCode;

}
