package com.fjhx.item.entity.product.dto;

import com.fjhx.file.entity.ObsFile;
import com.fjhx.item.entity.product.po.ProductBomDetail;
import com.fjhx.item.entity.product.po.ProductInfo;
import lombok.Getter;
import lombok.Setter;

import java.util.List;

/**
 * 产品库新增编辑入参实体
 *
 * @author zlj
 * @since 2023-03-17
 */
@Getter
@Setter
public class ProductInfoDto extends ProductInfo {

    private List<ObsFile> fileList;

    /**
     * 部门id
     */
    private Long deptId;

    /**
     * 开始时间
     */
    private  String beginTime;

    /**
     * 结束时间
     */
    private  String endTime;

    /**
     * 数量
     */
    private  Integer count;

    /**
     * 国家表ID
     */
    private Long countryId;

    /**
     * 排序(10 销售量排序  20 销售额排序  30 采购量排序  40 采购额排序  50 生产总量排序)
     */
    private Integer sort;

    /**
     * 10 正序  20 倒序
     */
    private Integer orderBy;

    /**
     * 客户id
     */
    private Long customerId;

    /**
     * 产品id列表
     */
    private List<Long> productIds;

    /**
     * 生产文件列表
     */
    private List<ObsFile> prodFileList;

    /**
     * 产品BOM列表
     */
    private List<ProductBomDetail> productBomDetailList;

    /**
     * 产品定制信息列表
     */
    private List<ProductCustomInfoDto> productCustomInfoList;

    /**
     * 对外报价单产品id
     */
    private Long extQuotationProductId;
}
