package com.fjhx.item.entity.product.dto;

import com.ruoyi.common.core.domain.BaseSelectDto;
import lombok.Getter;
import lombok.Setter;

/**
 * 产品库列表查询入参实体
 *
 * @author zlj
 * @since 2023-03-17
 */
@Getter
@Setter
public class ProductInfoSelectDto extends BaseSelectDto {

    /**
     * 产品类型
     */
    private String type;

    /**
     * 定义 1产品 2物料
     */
    private Integer definition;

    /**
     * 产品分类id
     */
    private Long productClassifyId;

    /**
     * 维多利亚当前周期
     */
    private Integer lifeCycle;

    /**
     * 过滤组合
     */
    private Integer combination;

    /**
     * 部门id
     */
    private Long deptId;


    /**
     * 数量
     */
    private Integer count;

    /**
     * 国家表ID
     */
    private Long countryId;

    /**
     * 排序(10 销售量排序  20 销售额排序  30 采购量排序  40 采购额排序  50 生产总量排序)
     */
    private Integer sort;

    /**
     * 10 正序  20 倒序
     */
    private Integer orderBy;

    /**
     * 客户id
     */
    private Long customerId;

    /**
     * 产品名称
     */
    private String name;

    /**
     * 产品英文名称
     */
    private String englishName;


    /**
     * 自定义编码
     */
    private String customCode;

    /**
     * 条码编号
     */
    private String barCode;

    /**
     * 海关编号
     */
    private String customsCode;

    /**
     * 是否不显示原材料分类的数据
     */
    private Integer isNeRawMaterial;

    /**
     * 归属公司Id
     */
    private Long companyId;

    /**
     * 是否配置原材料 1有配置原材料 0没配置原材料的产品
     */
    private Integer isRawMaterial;

    /**
     * 物料id
     */
    private Long materialId;

    /**
     * 禁用权限 1禁用
     */
    private Integer disablePerm;

}
