package com.fjhx.item.entity.product.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;

/**
 * <p>
 * 产品库
 * </p>
 *
 * @author zlj
 * @since 2023-03-17
 */
@Getter
@Setter
@TableName("product_info")
public class ProductInfo extends BasePo {

    /**
     * 定义 1产品 2物料
     */
    private Integer definition;
    /**
     * 工艺id
     */
    Long technologyId;

    /**
     * 产品分类id
     */
    private Long productClassifyId;

    /**
     * 自定义编码
     */
    private String customCode;

    /**
     * 产品名称
     */
    private String name;
    /**
     * 产品编码
     */
    private String code;
    /**
     * 英文名
     */
    private String nameEnglish;
    /**
     * 销售价
     */
    private BigDecimal price;
    /**
     * 币种
     */
    private String currency;

    /**
     * 规格型号
     */
    private String spec;
    /**
     * 产品长
     */
    private BigDecimal length;
    /**
     * 产品宽
     */
    private BigDecimal width;
    /**
     * 产品高
     */
    private BigDecimal height;

    /**
     * 净重
     */
    private BigDecimal netWeight;

    /**
     * 海关编码
     */
    private String hsCode;

    /**
     * 备注
     */
    private String remark;

    /**
     * 生产图片地址
     */
    private String prodImgPath;

    /**
     * 生产文件地址
     */
    private String prodFilePath;

    /**
     * 原材料id
     */
    private Long rawMaterialId;

    //---------------------------------------------------------------

    /**
     * 材质
     */
    private String material;
    /**
     * 正面纹路
     */
    private String frontalTexture;
    /**
     * 反面纹路
     */
    private String reverseTexture;
    /**
     * 单位
     */
    private String unit;
    /**
     * 色层
     */
    private String colorLayer;
    /**
     * 颜色
     */
    private String color;
    /**
     * 安全库存
     */
    private BigDecimal stockThreshold;
    /**
     * 成本价
     */
    private BigDecimal costPrice;

    /**
     * 成本价币种
     */
    private String costCurrency;


    //---------------------------------------------------------------
    /**
     * 产品类型
     */
    private String type;


    /**
     * 产品spuid
     */
    private Long productSpuId;

    /**
     * 条码编号
     */
    private String barCode;

    /**
     * 结存单价
     */
    private BigDecimal unitPrice;

    /**
     * 归属公司Id
     */
    private Long companyId;

    //----------------------------------------
    /**
     * LOGO长
     */
    private BigDecimal logoLength;
    /**
     * LOGO宽
     */
    private BigDecimal logoWidth;
    /**
     * LOGO高
     */
    private BigDecimal logoHeight;
    /**
     * 几色印刷
     */
    private Integer colorCount;
    /**
     * 是否折叠
     */
    private Integer isFold;
    /**
     * 折叠数 字典（fold_way）
     */
    private String foldWay;
    /**
     * 包装要求 字典（pack_ask）
     */
    private String packAsk;
    /**
     * 是否定制
     */
    private Integer isCustomized;
    /**
     * 色卡号
     */
    private String colorCardCode;
    //-------------------------------------------
    /**
     * 出场价
     */
    private BigDecimal factoryPrice;
    /**
     * 平铺价
     */
    private BigDecimal flatPrice;

    /**
     * 无属性原材料id
     */
    private Long attrRawMaterialId;
}
