package com.fjhx.jushuitan.entity.jst;

import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;

@Getter
@Setter
public class ThematicAnalysisBo {
    /**
     * ERP内部订单号，聚水潭生成的订单号，唯一
     */
    private Long oid;
    /**
     * 多标签
     */
    private String labels;
    /**
     * 订单类型，普通订单；补发订单；分销Plus；供销Plus；换货订单
     */
    private String type;
    /**
     * 线上订单号，线上同步过来的订单号，最长不超过20;唯一
     */
    private String soId;

    /**
     * 聚水潭订单状态 待付款：WaitPay；发货中：Delivering；被合并：Merged；异常：Question；被拆分：Split；等供销商|外仓发货：WaitOuterSent；已付款待审核：WaitConfirm；已客审待财审：WaitFConfirm；已发货：Sent；取消：Cancelled
     */
    private String status;


    private String drpFrom;

    /**
     * 店铺名称
     */
    private String shopName;

    /**
     * 买家昵称
     */
    private String shopBuyerId;


    /**
     * 买家留言
     */
    private String buyerMessage;


    /**
     * 订单备注；卖家备注
     */
    private String remark;
    /**
     * 订单日期
     */
    private Date orderDate;
    /**
     * 发货日期
     */
    private Date sendDate;

    /**
     * 确认收货时间（仅限头条放心购、拼多多、苏宁易购、快手电商、有赞微商城，如果线上状态为取消，该时间为完结时间）
     */
    private Date endTime;

    /**
     * 订单业务员
     */
    private String creatorName;
    /**
     * 收件信息-收件人
     */
    private String receiverName;


    /**
     * 收件信息-省
     */
    private String receiverState;

    /**
     * 收件信息-市
     */
    private String receiverCity;

    /**
     * 收件信息-街道
     */
    private String receiverTown;

    /**
     * 快递公司
     */
    private String logisticsCompany;


    /**
     * 快递单号
     */
    private String lid;

    /**
     * 店铺站点信息
     */
    private String shopSite;

    /**
     * 订单来源，ERP：手工下单； COPY：复制； MERGE：合并； SPLIT：拆分；拆分还原； MOBILE：手机； IMPORT:导入； drp-s：供销推送； drp-d：分销推送； KWAISHOP：快手；微商城； PINDUODUO；拼多多； TOUTIAOFXG；头条放心购
     */
    private String orderFrom;

    /**
     * 店铺编号
     */
    private Integer shopId;

//================================================
    /**
     * 原始商品编码
     */
    private String skuId;
    /**
     * 款式编码
     */
    private String iid;
    /**
     * 原始线上单号
     */
    private String rawSoId;
    /**
     * 商品名称
     */
    private String name;
    /**
     * 店铺商品编码，对应店铺商品资料页面平台店铺商品编码
     */
    private String shopSkuId;
    /**
     * 基本售价（原价）
     */
    private BigDecimal basePrice;
    /**
     * 单价
     */
    private BigDecimal price;
    /**
     * 数量
     */
    private Integer qty;

    /**
     * 总额
     */
    private BigDecimal amount;


}
