package com.fjhx.mes.controller.production;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.mes.entity.MaterialBalanceBo;
import com.fjhx.mes.entity.production.dto.ProduceOrderSelectDto;
import com.fjhx.mes.entity.production.dto.ProductionOrderDto;
import com.fjhx.mes.entity.production.vo.ProductionOrderVo;
import com.fjhx.mes.service.production.ProduceOrderService;
import com.fjhx.sale.entity.contract.vo.ContractVo;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;


/**
 * <p>
 * 生产订单 前端控制器
 * </p>
 *
 * @author
 * @since 2024-01-10
 */
@RestController
@RequestMapping("/produceOrder")
public class ProduceOrderController {

    @Autowired
    private ProduceOrderService produceOrderService;

    /**
     * 生产订单分页
     */
    @PostMapping("/page")
    public Page<ProductionOrderVo> page(@RequestBody ProduceOrderSelectDto dto) {
        return produceOrderService.getPage(dto);
    }

    /**
     * 创建生产订单（投产）
     */
    @PostMapping("/createOrder")
    public void createOrder(@RequestBody ProductionOrderDto produceOrderDto) {
        produceOrderService.createOrder(produceOrderDto);
    }

    /**
     * 获取排程列表
     *
     * @return
     */
    @PostMapping("/schedulingList")
    public List<ProductionOrderVo> getSchedulingList(@RequestBody ProduceOrderSelectDto produceOrderDto) {
        return produceOrderService.getSchedulingList(produceOrderDto);
    }

    /**
     * 投产
     */
    @PostMapping("/editProduceTime")
    public void editProduceTime(@RequestBody ProduceOrderSelectDto dto) {
        produceOrderService.editProduceTime(dto);
    }

    /**
     * 交期确认
     */
    @PostMapping("/deliveryConfirm")
    public void deliveryConfirm(@RequestBody ProductionOrderDto dto) {
        produceOrderService.deliveryConfirm(dto);
    }

    /**
     * 交期修改
     */
    @PostMapping("/editDeliveryPeriod")
    public void editDeliveryPeriod(@RequestBody ProductionOrderDto dto) {
        produceOrderService.editDeliveryPeriod(dto);
    }

    /**
     * 生产订单明细
     */
    @PostMapping("/detail")
    public ProductionOrderVo detail(@RequestBody BaseSelectDto dto) {
        return produceOrderService.detail(dto.getId());
    }

    @PostMapping("/materialBalanceList")
    List<MaterialBalanceBo> materialBalanceList(@RequestBody BaseSelectDto dto) {
        return produceOrderService.materialBalanceList(dto.getId());
    }

    /**
     * 生产订单查看合同信息
     */
    @PostMapping("/contractInfo")
    public ContractVo contractInfo(@RequestBody BaseSelectDto dto) {
        return produceOrderService.contractInfo(dto.getId());
    }

}
