package com.fjhx.mes.controller.production;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.mes.entity.production.dto.ProductionTaskDto;
import com.fjhx.mes.entity.production.dto.ProductionTaskSelectDto;
import com.fjhx.mes.entity.production.vo.ProductionTaskVo;
import com.fjhx.mes.service.production.ProductionTaskService;
import com.ruoyi.common.core.domain.BaseSelectDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * <p>
 * 生产任务 前端控制器
 * </p>
 *
 * @author 
 * @since 2023-03-30
 */
//@DS(SourceConstant.MES)
@RestController
@RequestMapping("/productionTask")
public class ProductionTaskController {

    @Autowired
    private ProductionTaskService productionTaskService;

    /**
     * 生产任务分页
     */
    @PostMapping("/page")
    public Page<ProductionTaskVo> page(@RequestBody ProductionTaskSelectDto dto) {
        return productionTaskService.getPage(dto);
    }

    /**
     * 生产任务明细
     */
    @PostMapping("/detail")
    public ProductionTaskVo detail(@RequestBody BaseSelectDto dto) {
        return productionTaskService.detail(dto.getId());
    }

//    /**
//     * 生产任务新增
//     */
//    @PostMapping("/add")
//    public void add(@RequestBody ProductionTaskDto productionTaskDto) {
//        productionTaskService.add(productionTaskDto);
//    }

    /**
     * 生产任务编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody ProductionTaskDto productionTaskDto) {
        productionTaskService.edit(productionTaskDto);
    }

    /**
     * 生产任务删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        productionTaskService.delete(dto.getId());
    }

    /**
     * 生产任务新增 嘉兴双拓
     */
    @PostMapping("/addByJxst")
    public void addByJxst(@RequestBody ProductionTaskDto productionTaskDto) {
        productionTaskService.addByJxst(productionTaskDto);
    }

    /**
     * 生产任务明细 嘉兴双拓
     */
    @PostMapping("/detailByJxst")
    public ProductionTaskVo detailByJxst(@RequestBody BaseSelectDto dto) {
        return productionTaskService.detailByJxst(dto.getId());
    }

}
