package com.fjhx.mes.entity.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.domain.BaseSelectDto;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;

/**
 * 生产订单明细列表查询入参实体
 *
 * @author
 * @since 2024-01-10
 */
@Getter
@Setter
public class ProduceOrderDetailSelectDto extends BaseSelectDto {

    /**
     * 生产状态 0未开始 1进行中 2已完成
     */
    private String produceStatus;

    /**
     * 交期开始时间
     */
    private Date staDeliveryPeriod;

    /**
     * 交期结束时间
     */
    private Date endDeliveryPeriod;

    /**
     * 归属公司Id
     */
    private Long companyId;

    /**
     * 任务ID列表
     */
    private List<Long> taskIds;

    /**
     * 是否逾期
     */
    private Integer isOverdue;

    /**
     * 合同类型
     */
    private Integer contractType;

    /**
     * 业务公司
     */
    private Long contractCompanyId;

    /**
     * 工序id
     */
    private Long processesId;

    /**
     * 是否排程
     */
    private Integer isScheduling;

    /**
     * 排程时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date schedulingDate;

    /**
     * 是否在手
     */
    private Integer isHand;

}
