package com.fjhx.mes.entity.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.domain.BaseSelectDto;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;

/**
 * 生产订单列表查询入参实体
 *
 * @author
 * @since 2024-01-10
 */
@Getter
@Setter
public class ProduceOrderSelectDto extends BaseSelectDto {

    /**
     * 生产状态 0未开始 1进行中 2已完成
     */
    private String produceStatus;

    /**
     * 交期开始时间
     */
    private Date staDeliveryPeriod;

    /**
     * 交期结束时间
     */
    private Date endDeliveryPeriod;

    /**
     * 排程时间过滤
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM")
    private String beginDate;

    /**
     * 归属公司Id
     */
    private Long companyId;

    /**
     * 投产时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date produceTime;

    /**
     * 是否逾期
     */
    private Integer isOverdue;

    /**
     * 是否投产
     */
    private Integer isProduce;

    /**
     * 订单类型
     */
    private Integer contractType;

    /**
     * 业务公司
     */
    private Long contractCompanyId;

    /**
     * 生产状态反向过滤
     */
    private String neProduceStatus;

}
