package com.fjhx.mes.entity.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.domain.BaseSelectDto;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;

/**
 * 生产排程列表查询入参实体
 *
 * @author
 * @since 2024-02-03
 */
@Getter
@Setter
public class ProductionSchedulingSelectDto extends BaseSelectDto {

    /**
     * 归属公司id
     */
    private Long companyId;

    /**
     * 工序id
     */
    private Long processesId;

    /**
     * 排程时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date schedulingDate;

    /**
     * 业务公司
     */
    private Long contractCompanyId;

    /**
     * 生产状态 0未开始 1进行中 2已完成
     */
    private String produceStatus;
    /**
     * 是否逾期
     */
    private Integer isOverdue;

    /**
     * 交期开始时间
     */
    private Date staDeliveryPeriod;

    /**
     * 交期结束时间
     */
    private Date endDeliveryPeriod;


}
