package com.fjhx.mes.entity.production.vo;

import com.fjhx.mes.entity.production.po.ProductionOrderDetail;
import com.fjhx.sale.entity.contract.vo.ContractProductBomVo;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 生产订单明细列表查询返回值实体
 *
 * @author
 * @since 2024-01-10
 */
@Getter
@Setter
public class ProductionOrderDetailVo extends ProductionOrderDetail {

    /**
     * 订单变化
     */
    private String orderCode;

    /**
     * 订单创建时间
     */
    private Date orderCreateTime;

    /**
     * 产品名称
     */
    private String productName;
    /**
     * 产品编号
     */
    private String productCode;
    /**
     * 产品规格
     */
    private String productSpec;
    /**
     * 产品单位
     */
    private String productUnit;

    /**
     * 产品长
     */
    private BigDecimal productLength;
    /**
     * 产品宽
     */
    private BigDecimal productWidth;
    /**
     * 产品高
     */
    private BigDecimal productHeight;
    /**
     * 产品备注
     */
    private String productRemark;


    /**
     * 交期
     */
    private Date deliveryPeriod;

    /**
     * 生产用时
     */
    private Long usageTime;

    /**
     * 工序列表
     */
    private List<ProductionProcessesVo> productionProcessesList;

    /**
     * 原材料名称
     */
    private String rawMaterialName;

    /**
     * 原材料编号
     */
    private String rawMaterialCode;

    /**
     * 原材料长
     */
    private BigDecimal rawMaterialLength;
    /**
     * 原材料宽
     */
    private BigDecimal rawMaterialWidth;
    /**
     * 原材料高
     */
    private BigDecimal rawMaterialHeight;

    /**
     * 生产进度列表
     */
    private List<ProductionTaskProgressVo> productionTaskProgressList;

    /**
     * BOM列表
     */
    private List<ContractProductBomVo> contractProductBomList;

    /**
     * BOM列表
     */
    private List<ContractProductBomVo> contractProductAllBomList;

    /**
     * 投产时间
     */
    private Date produceTime;

    /**
     * 生产公司Id
     */
    private String companyName;

    /**
     * 是否逾期
     */
    private Integer isOverdue;

    private String productColor;

    /**
     * 生产指示
     */
    private String prodTag;

    /**
     * 生产备注
     */
    private String prodRemark;

    /**
     * 业务员id
     */
    private Long saleUserId;

    /**
     * 业务员名称
     */
    private String saleUserName;

    /**
     * 合同类型
     */
    private Integer contractType;

    private Long contractCompanyId;

    /**
     * 业务公司名称
     */
    private String contractCompanyName;
}
