package com.fjhx.mes.entity.production.vo;

import com.fjhx.mes.entity.production.po.ProductionOrder;
import com.fjhx.sale.entity.arrival.vo.ArrivalDetailVo;
import com.fjhx.sale.entity.purchase.vo.EhsdPurchaseProductVo;
import com.fjhx.wms.entity.stock.vo.StockJournalDetailsVo;
import lombok.Getter;
import lombok.Setter;

import java.util.List;

/**
 * 生产订单列表查询返回值实体
 *
 * @author
 * @since 2024-01-10
 */
@Getter
@Setter
public class ProductionOrderVo extends ProductionOrder {

    private List<ProductionOrderDetailVo> produceOrderDetailList;

    /**
     * 产品名称
     */
    private String productName;

    /**
     * 生产指示
     */
    private String prodTag;
    /**
     * 归属公司名称
     */
    private String companyName;

    /**
     * 是否逾期
     */
    private Integer isOverdue;

    /**
     * 生产备注
     */
    private String prodRemark;

    List<EhsdPurchaseProductVo> purchaseProductList;
    List<StockJournalDetailsVo> stockJournalDetailsList;

    /**
     * 确认状态
     */
    private Integer confirmStatus;

    /**
     * 合同类型
     */
    private Integer contractType;


    private Long contractCompanyId;

    /**
     * 业务公司名称
     */
    private String contractCompanyName;

    /**
     * 到货列表
     */
    private List<ArrivalDetailVo> arrivalDetailList;

}
