package com.fjhx.mes.mapper.production;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.mes.entity.production.po.ProductionOrderDetail;
import com.fjhx.mes.entity.production.vo.ProductionOrderDetailVo;
import com.fjhx.mes.entity.production.vo.ProductionSchedulingVo;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


/**
 * <p>
 * 生产订单明细 Mapper 接口
 * </p>
 *
 * @author
 * @since 2024-01-10
 */
@Mapper
public interface ProduceOrderDetailMapper extends BaseMapper<ProductionOrderDetail> {

    /**
     * 生产订单分页
     */
    Page<ProductionOrderDetailVo> getPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<ProductionOrderDetail> wrapper);

    Page<ProductionOrderDetailVo> schedulingTaskPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<ProductionOrderDetail> wrapper);

    /**
     * 获取所有工序指定日期排程信息
     */
    List<ProductionSchedulingVo> getProcessesSchedulingByDay(String dayDate);

    /**
     * 获取所有工序指定日期排程信息
     */
    List<ProductionSchedulingVo> getProcessesScheduling(@Param("dayDate") String dayDate, @Param("ew") IWrapper<ProductionOrderDetail> wrapper);
}
