package com.fjhx.mes.mapper.production;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.mes.entity.production.po.ProductionScheduling;
import com.fjhx.mes.entity.production.vo.ProductionOrderDetailVo;
import com.fjhx.mes.entity.production.vo.ProductionSchedulingVo;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 生产排程 Mapper 接口
 * </p>
 *
 * @author
 * @since 2024-02-03
 */
public interface ProductionSchedulingMapper extends BaseMapper<ProductionScheduling> {

    /**
     * 分页
     */
    Page<ProductionSchedulingVo> getPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<ProductionScheduling> wrapper);

    /**
     * 排程合并数量
     */
    List<ProductionSchedulingVo> listSumQuantity(@Param("ew") IWrapper<ProductionScheduling> wrapper);

    /**
     * 排程任务列表
     */
    List<ProductionOrderDetailVo> schedulingTaskList(@Param("ew") IWrapper<Object> wrapper);
}
