package com.fjhx.mes.service.production;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.mes.entity.MaterialBalanceBo;
import com.fjhx.mes.entity.production.dto.ProduceOrderSelectDto;
import com.fjhx.mes.entity.production.dto.ProductionOrderDto;
import com.fjhx.mes.entity.production.po.ProductionOrder;
import com.fjhx.mes.entity.production.vo.ProductionOrderVo;
import com.fjhx.sale.entity.contract.vo.ContractVo;
import com.ruoyi.common.core.service.BaseService;

import java.util.List;


/**
 * <p>
 * 生产订单 服务类
 * </p>
 *
 * @author
 * @since 2024-01-10
 */
public interface ProduceOrderService extends BaseService<ProductionOrder> {

    /**
     * 生产订单分页
     */
    Page<ProductionOrderVo> getPage(ProduceOrderSelectDto dto);

    /**
     * 下发生产
     */
    void createOrder(ProductionOrderDto produceOrderDto);

    /**
     * 获取排程列表
     */
    List<ProductionOrderVo> getSchedulingList(ProduceOrderSelectDto dto);

    /**
     * 修改投产时间
     */
    void editProduceTime(ProduceOrderSelectDto dto);

    /**
     * 交期确认
     */
    void deliveryConfirm(ProductionOrderDto dto);

    /**
     * 修改交期
     *
     * @param dto
     */
    void editDeliveryPeriod(ProductionOrderDto dto);

    ProductionOrderVo detail(Long id);

    /**
     * 物料结存
     */
    List<MaterialBalanceBo> materialBalanceList(Long id);

    ContractVo contractInfo(Long id);
}
