package com.fjhx.purchase.entity.subscribe.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 申购单
 * </p>
 *
 * @author
 * @since 2023-04-03
 */
@Getter
@Setter
@TableName("subscribe")
public class Subscribe extends BasePo {

	/**
	 * 部门名称
	 */
	private String deptName;

	/**
	 * 申购人名称
	 */
	private String subcribeName;

	/**
	 * 申购时间
	 */
	private Date subcribeTime;

	/**
	 * 申购编码
	 */
	private String code;

	/**
	 * 申购说明
	 */
	private String subcribeContent;

	/**
	 * 申购状态 0草稿 10、审批中；20、驳回  30、通过
	 */
	private Integer subcribeStatus;

	/**
	 * 审核通过时间
	 */
	private Date approvedDate;

	/**
	 * 流程id
	 */
	private String processInstanceId;

	/**
	 * 收货仓库ID
	 */
	private Long putWarehouseId;

	/**
	 * 要求到货时间
	 */
	private Date requiredArrivalTime;

	/**
	 * 是否删除
	 */
	private Integer delFlag;

	/**
	 * 流程实例
	 */
	private Long flowId;

	/**
	 * 归属公司id
	 */
	private Long companyId;

	/**
	 * 申请部门id
	 */
	private Long deptId;
	//====================================================
	/**
	 * 是否代替他人提交 0否 1是 附件类型10
	 */
	private Integer isSubstitute;
	/**
	 * 申请用途 附件类型15
	 */
	private String purposeRemark;
	/**
	 * 是否入库 1是 0否
	 */
	private Integer isInStock;
	/**
	 * 供应商id
	 */
	private Long supplierId;

	/**
	 * 金额
	 */
	private BigDecimal amount;
	/**
	 * 金额含税
	 */
	private BigDecimal amountIncludingTax;

	private Long subcribeUserId;


}
