package com.fjhx.sale.controller.contract;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.sale.entity.contract.dto.ContractOutboundInfoDto;
import com.fjhx.sale.entity.contract.dto.ContractOutboundInfoSelectDto;
import com.fjhx.sale.entity.contract.vo.ContractOutboundInfoVo;
import com.fjhx.sale.service.contract.ContractOutboundInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * <p>
 * 销售出货信息 前端控制器
 * </p>
 *
 * @author
 * @since 2024-03-13
 */
@RestController
@RequestMapping("/contractOutboundInfo")
public class ContractOutboundInfoController {
    @Autowired
    private ContractOutboundInfoService contractOutboundInfoService;

    @PostMapping("/page")
    Page<ContractOutboundInfoVo> getPage(@RequestBody ContractOutboundInfoSelectDto dto) {
        return contractOutboundInfoService.getPage(dto);
    }

    @PostMapping("/loadTruck")
    public void loadTruck(@RequestBody ContractOutboundInfoDto dto) {
        contractOutboundInfoService.loadTruck(dto);
    }

    @PostMapping("/detail")
    public ContractOutboundInfoVo detail(@RequestBody ContractOutboundInfoDto dto) {
        return contractOutboundInfoService.detail(dto.getId());
    }

}
