package com.fjhx.sale.entity.contract.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;

/**
 * <p>
 * 合同产品BOM
 * </p>
 *
 * @author
 * @since 2024-01-17
 */
@Getter
@Setter
@TableName("contract_product_bom")
public class ContractProductBom extends BasePo {

    /**
     * 产品id
     */
    private Long productId;

    /**
     * 商品名称
     */
    private String productName;

    /**
     * 商品型号
     */
    private String productModel;

    /**
     * 商品数量
     */
    private BigDecimal quantity;

    /**
     * 商品单价
     */
    private BigDecimal price;

    /**
     * 商品金额
     */
    private BigDecimal amount;

    /**
     * 备注
     */
    private String remark;

    /**
     * 物料id
     */
    private Long materialId;

    /**
     * 物料成本价
     */
    private BigDecimal costPrice;

    /**
     * 物料销售价
     */
    private BigDecimal salePrice;

    /**
     * 物料类型1原材料 2包材辅材
     */
    private Integer type;

    /**
     * 合同id
     */
    private Long contractId;

    /**
     * 合同产品表id
     */
    private Long contractProductId;

    /**
     * 报价产品BOM表id
     */
    private Long quotationProductBomId;

    /**
     * 原BOMId
     */
    private Long oldContractProductBomId;

}
