package com.fjhx.sale.entity.ext.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;

/**
 * <p>
 * 对外报价单产品
 * </p>
 *
 * @author
 * @since 2024-01-14
 */
@Getter
@Setter
@TableName("ext_quotation_product")
public class ExtQuotationProduct extends BasePo {

    /**
     * 对外报价表ID
     */
    private Long saleQuotationId;

    /**
     * 商品ID
     */
    private Long productId;

    /**
     * 商品名称
     */
    private String productName;

    /**
     * 商品型号
     */
    private String productModel;

    /**
     * 商品数量
     */
    private BigDecimal quantity;

    /**
     * 商品单价
     */
    private BigDecimal price;

    /**
     * 商品金额
     */
    private BigDecimal amount;

    /**
     * 付款条件
     */
    private String remark;

    /**
     * 对内报价单物品表ID
     */
    private Long quotationProductId;

    //----------------------------------------
    /**
     * 商品名称
     */
    private String productCode;
    /**
     * 产品长
     */
    private BigDecimal productLength;
    /**
     * 产品宽
     */
    private BigDecimal productWidth;
    /**
     * 产品高
     */
    private BigDecimal productHeight;
    /**
     * 产品高
     */
    private String productColor;
    /**
     * 色卡号
     */
    private String colorCardCode;
    /**
     * 净重
     */
    private BigDecimal netWeight;

    /**
     * LOGO长
     */
    private BigDecimal logoLength;
    /**
     * LOGO宽
     */
    private BigDecimal logoWidth;
    /**
     * LOGO高
     */
    private BigDecimal logoHeight;
    /**
     * 几色印刷
     */
    private Integer colorCount;
    /**
     * 是否折叠
     */
    private Integer isFold;
    /**
     * 折叠数 字典（fold_way）
     */
    private String foldWay;
    /**
     * 包装要求 字典（pack_ask）
     */
    private String packAsk;
    /**
     * 是否定制
     */
    private Integer isCustomized;

    /**
     * 原材料id
     */
    private Long rawMaterialId;

    /**
     * 工艺id
     */
    private Long technologyId;

}
