package com.fjhx.sale.entity.ext.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;

/**
 * <p>
 * 对外报价单产品BOM
 * </p>
 *
 * @author
 * @since 2024-01-14
 */
@Getter
@Setter
@TableName("ext_quotation_product_bom")
public class ExtQuotationProductBom extends BasePo {

    /**
     * 对外报价产品表id
     */
    private Long quotationProductId;

    /**
     * 产品id
     */
    private Long productId;

    /**
     * 商品名称
     */
    private String productName;

    /**
     * 商品型号
     */
    private String productModel;

    /**
     * 商品数量
     */
    private BigDecimal quantity;

    /**
     * 商品单价
     */
    private BigDecimal price;

    /**
     * 商品金额
     */
    private BigDecimal amount;

    /**
     * 备注
     */
    private String remark;

    /**
     * 物料id
     */
    private Long materialId;

    /**
     * 对内产品BOM表id
     */
    private Long quotationProductBomId;

    /**
     * 成本价
     */
    private BigDecimal costPrice;
    /**
     * 销售价
     */
    private BigDecimal salePrice;
    /**
     * 物料类型 1原材料 2包材辅材
     */
    private Integer type;

    private Long extQuotationId;

}
