package com.fjhx.sale.entity.ext.vo;

import com.fjhx.sale.entity.ext.po.ExtQuotationProduct;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 对外报价单产品列表查询返回值实体
 *
 * @author
 * @since 2024-01-14
 */
@Getter
@Setter
public class ExtQuotationProductVo extends ExtQuotationProduct {

    List<ExtQuotationProductBomVo> quotationProductBomList;
    private String extQuotationCode;
    private String quotationCode;

    private String productCode;
    private String productName;
    private BigDecimal productLength;
    private BigDecimal productWidth;
    private BigDecimal productHeight;
    private String productColor;

    /**
     * 生产图片地址
     */
    private String productProdImgPath;


    List<ExtQuotationProductCustomInfoVo> quotationProductCustomInfoList;

    /**
     * 原材料名称
     */
    private String rawMaterialName;
    /**
     * 原材料编号
     */
    private String rawMaterialCode;
    /**
     * 原材料颜色
     */
    private String rawMaterialColor;
    /**
     * 原材料色卡号
     */
    private String rawMaterialColorCardCode;
    /**
     * 原材料长
     */
    private BigDecimal rawMaterialLength;
    /**
     * 原材料宽
     */
    private BigDecimal rawMaterialWidth;
    /**
     * 原材料高
     */
    private BigDecimal rawMaterialHeight;

    /**
     * 原材料净重
     */
    private String rawMaterialNetWeight;

    /**
     * 待创建产品生成时间
     */
    private Date waitProductTime;

    /**
     * 业务成本单价
     */
    private BigDecimal businessCostPrice;

}
