package com.fjhx.sale.entity.purchase.vo;

import com.fjhx.sale.entity.purchase.po.EhsdPurchaseProduct;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;

/**
 * ehsd采购产品表列表查询返回值实体
 *
 * @author
 * @since 2023-05-17
 */
@Getter
@Setter
public class EhsdPurchaseProductVo extends EhsdPurchaseProduct {

    /**
     * 合同ID
     */
    private Long contractId;

    /**
     * 金额-货品
     */
    private String currencyAmount;

    /**
     * 币种
     */
    private String currency;

    /**
     * 产品定义
     */
    private Integer definition;

    private BigDecimal rate;

    /**
     * 待采购数量
     */
    private BigDecimal expendQuantity;

    /**
     * 分类ID
     */
    private Long productCategoryId;

    /**
     * 分类ID集合
     */
    private String productCategoryIds;

    /**
     * 产品编号
     */
    private String productCode;
    /**
     * 产品规格
     */
    private String productSpec;

    /**
     * 采购单号
     */
    private String purchaseCode;

    /**
     * 产品长
     */
    private BigDecimal productLength;
    /**
     * 产品宽
     */
    private BigDecimal productWidth;
    /**
     * 产品高
     */
    private BigDecimal productHeight;

    /**
     * 销售订单号
     */
    private String saleCode;

    private String productColor;

    private BigDecimal arrivalQuantity;

    /**
     * 供应商id
     */
    private Long sellCorporationId;
    /**
     * 供应商名称
     */
    private String sellCorporationName;


    /**
     * 单位
     */
    private String productUnit;
    /**
     * 净重
     */
    private BigDecimal productNetWeight;
    /**
     * 正面纹路
     */
    private String productFrontalTexture;
    /**
     * 反面纹路
     */
    private String productReverseTexture;
}
