package com.fjhx.sale.entity.sale.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 报价表
 * </p>
 *
 * @author
 * @since 2023-04-14
 */
@Getter
@Setter
@TableName("sale_quotation")
public class SaleQuotation extends BasePo {

    /**
     * 报价单编号
     */
    private String code;

    /**
     * 报价单类型
     */
    private Integer type;

    /**
     * 归属公司Id
     */
    private Long companyId;

    /**
     * 买方公司ID
     */
    private Long buyCorporationId;

    /**
     * 买方联系人名称
     */
    private String buyContactName;

    /**
     * 买方联系人电话
     */
    private String buyContactNumber;

    /**
     * 买方国家表id
     */
    private Long buyCountryId;

    /**
     * 买方省份id
     */
    private Long buyProvinceId;

    /**
     * 买方城市id
     */
    private Long buyCityId;

    /**
     * 买方详细地址
     */
    private String buyAddress;

    /**
     * 买方邮编
     */
    private String buyPostalCode;

    /**
     * 报价金额
     */
    private BigDecimal amount;

    /**
     * 报价时间
     */
    private Date quotationTime;

    /**
     * 报价状态 0未报价 1报价中 2已报价
     */
    private Integer quotationStatus;

    /**
     * 审批状态。10:发起。20 驳回。30通过
     */
    private Integer status;

    /**
     * 数据分组id
     */
    private Long groupId;

    /**
     * 上一版本id
     */
    private Long oldQuotationId;

    /**
     * 对外报价单id
     */
    private Long extQuotationId;

    /**
     * 退回原因
     */
    private String backRemark;

    /**
     * 归属公司id
     */
    private Long ofCompanyId;

    /**
     * 确认状态 0未确认 2已确认
     */
    private Integer confirmStatus;

    private BigDecimal prodAmount;

    /**
     * 归属部门id
     */
    private Long ofDeptId;

    /**
     * 议价备注
     */
    private String discussRemark;

    /**
     * 业务成本总金额
     */
    private BigDecimal businessCostAmount;
}
