package com.fjhx.sale.mapper.claim;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.common.entity.claim.ClaimContract;
import com.fjhx.common.entity.claim.vo.ClaimContractVo;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


/**
 * <p>
 * 到账认领-合同关联表 Mapper 接口
 * </p>
 *
 * @author
 * @since 2023-04-18
 */
public interface ClaimContractMapper extends BaseMapper<ClaimContract> {

    /**
     * 到账认领-合同关联表分页
     */
    Page<ClaimContractVo> getPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<ClaimContract> wrapper);

    List<ClaimContractVo> getList(@Param("ew") IWrapper<ClaimContract> wrapper);


    /**
     * 通过合同ID集合查询列表
     *
     * @param wrapper
     * @return
     */
    List<ClaimContract> getListByContractIds(@Param("ew") IWrapper<ClaimContract> wrapper);

    /**
     * 根据合同号查询流水ID
     * @param contractCode
     * @return
     */
    List<Long> getAccountWaterIdsByContractCode(@Param("contractCode") String contractCode);
}
