package com.fjhx.sale.mapper.claim;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.account.entity.account.po.AccountRunningWater;
import com.fjhx.account.entity.account.vo.AccountRunningWaterVo;
import com.fjhx.common.entity.claim.po.Claim;
import com.fjhx.common.entity.claim.vo.ClaimContractVo;
import com.fjhx.common.entity.claim.vo.ClaimVo;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


/**
 * <p>
 * 到账认领 Mapper 接口
 * </p>
 *
 * @author
 * @since 2023-04-18
 */
public interface ClaimMapper extends BaseMapper<Claim> {

    /**
     * 到账认领分页
     */
    Page<ClaimVo> getPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<Claim> wrapper);

    /**
     * 查询认领记录 businessId 流水表ID
     */
    List<ClaimContractVo> claimRecord(@Param("ew") LambdaQueryWrapper<Claim> eq);

    Page<AccountRunningWaterVo> claimInfoPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<AccountRunningWater> wrapper);
}
