package com.fjhx.sale.service.claim;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.common.entity.claim.ClaimContract;
import com.fjhx.common.entity.claim.dto.ClaimContractDto;
import com.fjhx.common.entity.claim.dto.ClaimContractSelectDto;
import com.fjhx.common.entity.claim.vo.ClaimContractVo;
import com.ruoyi.common.core.service.BaseService;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


/**
 * <p>
 * 到账认领-合同关联表 服务类
 * </p>
 *
 * @author
 * @since 2023-04-18
 */
public interface ClaimContractService extends BaseService<ClaimContract> {

    /**
     * 到账认领-合同关联表分页
     */
    Page<ClaimContractVo> getPage(ClaimContractSelectDto dto);

    List<ClaimContractVo> getList(@Param("ew") IWrapper<ClaimContract> wrapper);

    /**
     * 到账认领-合同关联表明细
     */
    ClaimContractVo detail(Long id);

    /**
     * 到账认领-合同关联表新增
     */
    void add(ClaimContractDto claimContractDto);

    /**
     * 到账认领-合同关联表编辑
     */
    void edit(ClaimContractDto claimContractDto);

    /**
     * 到账认领-合同关联表删除
     */
    void delete(Long id);

    /**
     * 通过合同ID集合查询列表
     * @param contractIds
     * @return
     */
    List<ClaimContract> getListByContractIds(List<Long> contractIds);

    /**
     * 根据合同号查询流水ID
     * @param code
     * @return
     */
    List<Long> getAccountWaterIdsByContractCode(String code);
}
