package com.fjhx.supply.entity.supplier.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.common.core.domain.BasePo;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 供应商
 * </p>
 *
 * @author
 * @since 2023-03-17
 */
@Getter
@Setter
@TableName("supplier_info")
public class SupplierInfo extends BasePo {

    /**
     * 供应商编码
     */
    private String code;

    /**
     * 供应商类型 1贸易商 2工厂
     */
    private String type;

    /**
     * 供应商名称
     */
    private String name;

    /**
     * 国家id
     */
    private Long countryId;

    /**
     * 省id
     */
    private Long provinceId;

    /**
     * 市id
     */
    private Long cityId;

    /**
     * 地区明细
     */
    private String areaDetail;

    /**
     * 联系人
     */
    private String contactPerson;

    /**
     * 联系电话
     */
    private String contactNumber;

    /**
     * 备注
     */
    private String remark;

    /**
     * 账户名
     */
    private String openingName;

    /**
     * 开户银行
     */
    private String openingBank;

    /**
     * 开户账号
     */
    private String accountOpening;

    /**
     * 联行号
     */
    private String interbankNumber;

    /**
     * 账期（/天）
     */
    private Integer accountPeriod;

    /**
     * 账期说明
     */
    private String accountPeriodRemark;

    /**
     * 个数
     */
    private Integer count;

    /**
     * 归属公司id
     */
    private Long companyId;

    /**
     * 传真
     */
    private String fax;

    /**
     * 邮编
     */
    private String postalCode;

    //--------------------------------------------------------------------
    /**
     * 供应商等级（字典supplier_grade）
     */
    private String grade;
    /**
     * 供应商状态（字典supplier_status）
     */
    private String status;
    /**
     * 开发人员id
     */
    private String devUserId;
    /**
     * 所属部门（供应商开发人员的所属部门）
     */
    private String deptId;
    /**
     * 纳税人识别号
     */
    private String taxpayerCode;
    /**
     * 发票类型
     */
    private String invoiceType;
    /**
     * 开票名称
     */
    private String invoiceName;
    /**
     * 开票地址
     */
    private String invoiceAddress;
    /**
     * 开票联系方式
     */
    private String invoiceContactInfo;
    /**
     * 对私_账户名
     */
    private String privOpeningName;
    /**
     * 对私_开户银行
     */
    private String privOpeningBank;
    /**
     * 对私_开户账号
     */
    private String privAccountOpening;
    /**
     * 对私_是否含税 1是 0不是
     */
    private String privIncludingTax;
    /**
     * 对私_税点（字典tax_points）
     */
    private String privTaxPoints;


}
