package com.fjhx.supply.service.supplier;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.supply.entity.supplier.dto.SupplierPriceDto;
import com.fjhx.supply.entity.supplier.dto.SupplierPriceSelectDto;
import com.fjhx.supply.entity.supplier.po.SupplierPrice;
import com.fjhx.supply.entity.supplier.vo.SupplierPriceAddVo;
import com.fjhx.supply.entity.supplier.vo.SupplierPriceVo;
import com.ruoyi.common.core.service.BaseService;

import java.util.List;
import java.util.Map;


/**
 * <p>
 * 供应商价格 服务类
 * </p>
 *
 * @author zlj
 * @since 2023-03-17
 */
public interface SupplierPriceService extends BaseService<SupplierPrice> {

    /**
     * 供应商价格分页
     */
    Page<SupplierPriceVo> getPage(SupplierPriceSelectDto dto);

    /**
     * 供应商价格新增
     *
     * @return
     */
    SupplierPriceAddVo add(SupplierPriceDto supplierPriceDto);

    /**
     * 供应商价格编辑
     */
    void edit(SupplierPriceDto supplierPriceDto);

    /**
     * 供应商价格删除
     */
    void delete(Long id);

    /**
     * 根据供应商id和产品列表获取价格
     */
    Map<Long, SupplierPrice> getSupplierPriceByProductIds(SupplierPriceDto dto);

    /**
     * 查某产品前n条低价供应商
     */
    List<SupplierPriceVo> getTopPriceList(List<Long> productIds, Integer count);
}
