package com.fjhx.wms.entity.stock.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fjhx.file.entity.ObsFile;
import com.fjhx.wms.entity.stock.po.StockWait;
import com.fjhx.wms.entity.stock.po.StockWaitDetails;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.List;

/**
 * 待出入库新增编辑入参实体
 *
 * @author
 * @since 2023-03-22
 */
@Getter
@Setter
public class StockWaitDto extends StockWait {

    /**
     * 入库仓库id
     */
    private Long warehouseId;

    /**
     * 待入库明细列表
     */
    private List<StockWaitDetails> stockWaitDetailsList;


    /**
     * 物流公司编号
     */
    private String logisticsCompanyCode;
    /**
     * 物流编号
     */
    private String logisticsCode;

    /**
     * 国家表id
     */
    private Long countryId;

    /**
     * 省份id
     */
    private Long provinceId;

    /**
     * 城市id
     */
    private Long cityId;

    /**
     * 详细地址
     */
    private String address;

    /**
     * 附件信息
     */
    private List<ObsFile> fileList;

    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date inOutTime;

}
