package com.fjhx.wms.entity.stock.vo;

import com.fjhx.wms.entity.stock.po.StockWaitDetails;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;

/**
 * 待出入库明细列表查询返回值实体
 *
 * @author
 * @since 2023-04-13
 */
@Getter
@Setter
public class StockWaitDetailsVo extends StockWaitDetails {

    /**
     * 产品名称
     */
    private String productName;

    /**
     * 产品编号
     */
    private String productCode;

    /**
     * 产品类型
     */
    private String productType;

    /**
     * 规格型号
     */
    private String productSpec;

    /**
     * 单位
     */
    private String productUnit;

    /**
     * 产品定义
     */
    private Integer productDefinition;

    /**
     * 业务编号
     */
    private String businessCode;

    /**
     * 业务id
     */
    private Long businessId;

    /**
     * 业务类型
     */
    private Integer businessType;

    /**
     * 出入库状态
     */
    private Integer status;

    /**
     * 已出库数量
     */
    private BigDecimal receiptQuantity;

    /**
     * 产品自定义编码
     */
    private String productCustomCode;

    private BigDecimal productLength;
    private BigDecimal productWidth;
    private BigDecimal productHeight;
    private String productColor;

    /**
     * 可用库存
     */
    private BigDecimal availableQuantity;

    /**
     * 净重
     */
    private BigDecimal productNetWeight;
    /**
     * 正面纹路
     */
    private String productFrontalTexture;
    /**
     * 反面纹路
     */
    private String productReverseTexture;

    /**
     * 合同产品单价
     */
    private BigDecimal contractProductPrice;
    /**
     * 合同产品出厂价
     */
    private BigDecimal contractProductFactoryPrice;

    /**
     * 实际库存
     */
    private BigDecimal stockQuantity;

}
